from __future__ import absolute_import
import time
from .console_colors import console_colors as cc
from inspect import getframeinfo, stack

time_tic=[]
names_tic=[]

# Timing info helpers

def tic(timer_name="Unnamed timer"):
    global time_tic
    time_tic.append(time.time())
    names_tic.append(timer_name)
    print('[' + cc.INFO +'Timer'  + cc.OFF + '] ' + ':: '*len(time_tic)  + '' + 
          str(names_tic[-1]) +  ': ' +   cc.INFO + 'Started.' + cc.OFF)

def toc():
    if 'time_tic' in globals():
        print('[' + cc.INFO +'Timer'  + cc.OFF + '] ' + ':: '*len(time_tic)  + '' +
              str(names_tic.pop()) + ': ' + cc.INFO + 'Elapsed time is ' + 
              str(time.time() - time_tic.pop()) + ' seconds.' + cc.OFF)
    else:
        print('[' + cc.FAIL +'ERROR'  + cc.OFF + '] ' + 'Toc: start time not set')
     
def info(msg, show_caller=False):
    caller = getframeinfo(stack()[1][0])
    if show_caller:
        print('[' + cc.OK +'Info'  + cc.OFF + '] ' + ':: ' + 
          cc.UL + '%s at line %d:'%(caller.filename,caller.lineno) + 
          cc.OFF + '\n%s'%msg)
    else:
        print('[' + cc.OK +'Info'  + cc.OFF + '] ' + ':: ' +  cc.OFF + ' %s'%msg)
     
def debug(msg):
    caller = getframeinfo(stack()[1][0])
    print('[' + cc.WARN +'Debug'  + cc.OFF + '] ' + 
          cc.UL + '%s at line %d:'%(caller.filename,caller.lineno) + 
          cc.OFF + '\n%s'%msg)

     
        

# Calculation shortcuts

from scipy.stats.kde import gaussian_kde as gkde
from numpy import argsort, round
def est_mode(values, mode_mode='kde', accuray = 'quick'):
    '''
    Function to obtain estimates of the posterior from discrete sampled values.
    
    :param values:    Array with the values.
    :param mode_mode: The mode of mode estimation. 
                      'kde': Use gaussian kernel density estimation
    :param accuracy:  Accuracy used in the estimation: 'quick'.
    
    :returns:         Estimate of the posterior density.
    
    :raises NotImplementedError:  Raises an exception if something else than 
                      the currently implemented method is requested.
                       
    '''
    if mode_mode is 'kde':
        if accuray is 'quick':
            values=values[::len(values)/8000] #Thin down to 20000 values
        density = gkde(values)
        return(values[argsort(density(values))[-1]])
            
    else:
        raise(NotImplementedError('Nothing implemented yet. One alternative is'+ 
            ' rounding the values and taking the mode.')) 
        
        


        
        
            
    