import time
import os

def out(basename, use_datestamp = True, avoid_collision = True):
    """ Generates an output folder name
    :param basename: The base part of the folder name
    :param use_datestamp: Prepend the filename with a datestamp (YYMMDD-)
    :param avoid_colision: Tests whether there already exists the desired
                           folder name. If it does, a version number is appended
                           to create a new unique folder name
                           
    :return: Returns the generated filename
                           
    :Example:
    
    out('data1')  # 07/28/16, with two result sets already existing
    > 160728-data1-2 
                           
    """ 
    
    pre = ""
    if use_datestamp:
        pre = time.strftime("%y%m%d")
        
    fn = pre + '-' + basename
    
    if not avoid_collision:
        print("no avoid")
        return fn
    else:
        if not os.path.isdir(fn):
            print("does not exists!!")
            return fn
        # If we haven't returned, start increasing the verison number until we find 
        # a free name    
        num = 1   
        print("here!!")
        while os.path.isdir(fn + '-' + str(num)):
            num = num +  1
            
        return fn + '-' + str(num)