import tvatoj
from matplotlib.pylab import plt 
from numpy import exp, abs, array, percentile, reshape, mean, arange
from scipy.stats import mode
from pymc3 import hpd, sample_ppc
from math import sqrt, floor, ceil
from tvatoj import tic, toc
from tvatoj import debug



def plot_pp(trace, model, tojs, subject_id, condition, relative = True, 
            color='black', ax=None, nsamples=1000, normalize=True, 
            hdi_alphas=arange(0.05,1,0.10), **kwargs):
            
    tic('Plotting posterior predictive for subject ' + str(subject_id))

    if ax is None:
        ax = plt.subplot()
    
   # toj_s = tojs[tojs['Subject_id']==subject_id]
   # toj_c = tojs[tojs['Condition']==condition]
   # toj_sc = toj_s[toj_s['Condition']==condition]
    
    toj = tojs[(tojs['Condition']==condition) & (tojs['Subject_id']==subject_id)]
    
    idx = list(tojs[tojs['Condition']==condition]['Subject_id'])
    #print idx
    repetitions =  toj['Repetitions']  #list(tojs[tojs['Condition']==condition]['Repetitions'])
   # print idx
    SOA = toj['SOA'] #list(tojs[tojs['Condition']==condition]['SOA'])
   # repetitions = list(tojs[tojs['Condition']==condition]['SOA'])
   # print SOA
   
    #rsn = toj['Running_subject_number'][0]
    first = idx.index(subject_id)
    last =first+len(set(SOA))
    
    ax = tvatoj.plot_toj(toj, ax=ax,color=color,mew=2, **kwargs) 
    #print trace.get_values('theta')
    
    tic('Drawing ' + str(nsamples) + ' posterior predictive samples')
    pp = sample_ppc(trace, model = model, samples= nsamples)
    toc()
    
    #print ppc
    pps =  pp['y'][:,first:last]
    #repetitions = array(repetitions[first:last])
    #SOA = array(SOA[first:last])
    
        
    pps_hdi = {}
    for i,alpha in enumerate(hdi_alphas):
        pps_hdi= hpd(pps, alpha = alpha)
        if normalize == True:
            pps_hdi[:,0] = pps_hdi[:,0] / repetitions
            pps_hdi[:,1] = pps_hdi[:,1] / repetitions
        ax.fill_between(SOA,pps_hdi[:,0],pps_hdi[:,1],color=color,alpha=0.22/(i+1.0))
    toc()
    
    return ax


  

